function init()
	man = FindBody("gangsta")
	isBroken = false
	playerDamage = 0.3
	SD = LoadSound("MOD/enemies/rollermines/selfdetonate.ogg")
	TA = LoadSound("MOD/enemies/rollermines/targetacquired.ogg")
	zap = LoadSound("MOD/enemies/rollermines/kazap.ogg")
	warning = FindLights("bomblights")
	--- weight value to dictate how much the man moves towards player
	weight = 0.3
	timer = 0
	minDist = 20
end

function tick(dt)
	timer = timer + dt
	if not isBroken and IsBodyBroken(man) then
		isBroken = true
	end
	if not isBroken then
		local a = GetPlayerTransform()
		local b = GetBodyTransform(man)
		direction = TransformToParentVec(b, Vec(0, -1, 0))
		local midDist = 1
		local distToPlayer = VecLength(VecSub(a.pos, b.pos))
		local bias = Vec(0,0,0)
		if not activated then
			SetLightEnabled(warning, false)
			activated = true
		end
		if (distToPlayer < minDist) and (distToPlayer < midDist) then
			if not karoc then
				PlaySound(TA)
				karoc = true
				minDist = minDist * 5000
			end
			if timer > 2 then
				SetPlayerHealth(GetPlayerHealth()-playerDamage)
				PlaySound(zap)
				timer = 0
				for i=1,3 do
					--- check if pos for index i is greater than or less than players
					--- set bias to negative or positive the weight value depending on pos
					if (a.pos[i] > b.pos[i]) then
						bias[i] = -weight * 30
						minDist = minDist * 5000
					elseif (a.pos[i] < b.pos[i]) then
						bias[i] = weight * 30
						minDist = minDist * 5000
					else
						bias[i] = 0
					end
				end
				SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
			end
		end
		if (distToPlayer < minDist) and (distToPlayer > midDist) then
			minDist = minDist * 5000
			local relativeVec = VecSub(a.pos, b.pos)
			--- get unit vector (vector of length 1 - what direction is it)
			if not pizgec then
				PlaySound(TA)
				pizgec = true
			end
			for i=1,3 do
				--- check if pos for index i is greater than or less than players
				--- set bias to negative or positive the weight value depending on pos
				if(a.pos[i]<b.pos[i]) then
					bias[i] = -weight
				elseif(a.pos[i]>b.pos[i]) then
					bias[i] = weight
				else
					bias[i] = 0
				end
			end
			SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
		end
	end
end