function init()
	checkTime = 0
	isTriggered = false
	isBroken = false
	runTrigger = FindTrigger("run")
	actionTrigger = FindTrigger("action")
	weight = 0.2
	weibt = 10
	weightatt = 0.2
	man = FindBody("zbrains")
	hed = FindBody("zhead")
	eyes = FindShape("headers")
	t1 = FindShape("ztorso")
	l1 = FindShape("zleg1")
	l2 = FindShape("zleg2")
	h1 = FindShape("zhand1")
	h2 = FindShape("zhand2")
	p1 = FindShape("zpelvis")
	lu = FindShape("zleftup")
	ru = FindShape("zrightup")
	midDist = 100
	timer = 0
	legspeed = 90
	broken = IsBodyBroken(hed)
	broken1 = IsBodyBroken(man)
	minDist = 60
	boc = 1.6
	Thimer = 0
	trommer = 0
	troimmer = 0
	bimer = 0
	losetime = 5
	damage = 0.4
	armspeed = 100
	miss = {
		LoadSound("MOD/enemies/zombie/miss.ogg"),
		LoadSound("MOD/enemies/zombie/miss1.ogg"),
		LoadSound("MOD/enemies/zombie/miss2.ogg"),
		LoadSound("MOD/enemies/zombie/miss3.ogg"),
		LoadSound("MOD/enemies/zombie/miss4.ogg")
	}
end

function tick(deltaTime)
	checkTime = checkTime + deltaTime
	if checkTime > 1 then
		isTriggered = checkTrigger()
		checkTime = 0
	end
	if isTriggered and not isBroken then
		gunTrans = GetShapeWorldTransform(eyes)
		gunPos = gunTrans.pos
		direction = TransformToParentVec(gunTrans, Vec(0, -1, 0))
		shootPos = VecAdd(gunPos, VecScale(direction,0.2))
		bomer = math.random(1,4)
		PL1 = GetShapeWorldTransform(eyes)
		if canSeePlayer() then
			seeplayer = true
			bimer = 0
		else
			bimer = bimer + deltaTime
			if bimer > losetime then
				seeplayer = false
			end
		end
		--this part is for basically saying "the zombie died", if it dies, the important values are reduced to 0, and the code stops repeating
		timer = timer + deltaTime
		if IsShapeBroken(t1) then
			isBroken = true
		end
		if IsBodyBroken(hed) then
			isBroken = true
			boc = 0
		end
		--this part is for basically saying "the zombie died" (repeating the same thing to make extra extra sure)
		if IsBodyBroken(man) then
			isBroken = true
			boc = 0
		end
		--this part is for checking if the zombie sprained their ankle or something, if they did, they become weaker and have a harder time moving their legs and standing up
		--this part is for making the head stay up while the zombie is alive
		timer = timer + 0.01
		local a = GetPlayerCameraTransform()
		local b = GetBodyTransform(man)
		local bias = Vec(0, boc, 0)
		local biasatt = Vec(0, 0, 0)
		SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
		if seeplayer then
			trommer = trommer + deltaTime
			troimmer = troimmer + deltaTime
			for i = 1, 3 do
				if (a.pos[i] > b.pos[i]) then
					bias[i] = weight * armspeed
					minDist = minDist * 5000
				elseif (a.pos[i] < b.pos[i]) then
					bias[i] = -weight * armspeed
					minDist = minDist * 5000
				else
					bias[i] = 0
				end
			end
			if trommer > bomer then
				local H1 = GetShapeBody(h1)
				SetBodyVelocity(H1, VecAdd(GetBodyVelocity(H1), bias))
				trommer = 0
				PlaySound(miss[math.random(#miss)])
			end
			if troimmer > bomer * 2 then
				local H2 = GetShapeBody(h2)
				SetBodyVelocity(H2, VecAdd(GetBodyVelocity(H2), bias))
				troimmer = 0
				PlaySound(miss[math.random(#miss)])
			end

			--the next part takes care of the legs and the leg timer.
			if timer > 1 then
				Thimer = Thimer + deltaTime
			end
			if timer > 2 then
				timer = 0
				for i = 1, 3 do
					if (a.pos[i] > b.pos[i]) then
						bias[i] = weight * legspeed
						minDist = minDist * 5000
					else
						if (a.pos[i] < b.pos[i]) then
							bias[i] = -weight * legspeed
							minDist = minDist * 5000
						else
							bias[i] = 0
						end
					end
				end
				local L1 = GetShapeBody(l1)
				SetBodyVelocity(L1, VecAdd(GetBodyVelocity(L1), bias))
				SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
				local H1 = GetShapeBody(h1)
				SetBodyVelocity(H1, VecAdd(GetBodyVelocity(H1), bias))
				local H2 = GetShapeBody(h2)
				SetBodyVelocity(H2, VecAdd(GetBodyVelocity(H2), bias))
				if Thimer > 0.5 then
					Thimer = 0
					for i = 1, 3 do
						bias[2] = 0
						if (a.pos[i] > b.pos[i]) then
							bias[i] = weight
							minDist = minDist * 5000
						else
							if (a.pos[i] < b.pos[i]) then
								bias[i] = -weight
								minDist = minDist * 5000
							else
								bias[i] = 0
							end
						end
						local L2 = GetShapeBody(l2)
						SetBodyVelocity(L2, VecAdd(GetBodyVelocity(L2), bias))
					end
				end
			end
		end
	end
end

function checkTrigger()
	return IsPointInTrigger(runTrigger, GetPlayerTransform().pos)
end

function canSeePlayer()
	return IsPointInTrigger(actionTrigger, GetPlayerTransform().pos)
end