function init()
	--- the introduction part, everything is as it seems
	isBroken = false
	weight = 0.2
	weibt = 10
	weightatt = 0.2
	man = FindBody("zbrains")
	hed = FindBody("zhead")
	eyes = FindShape("headers")
	t1 = FindShape("ztorso")
	l1 = FindShape("zleg1")
	l2 = FindShape("zleg2")
	h1 = FindShape("zhand1")
	h2 = FindShape("zhand2")
	p1 = FindShape("zpelvis")
	lu = FindShape("zleftup")
	ru = FindShape("zrightup")
	midDist = 100
	timer = 0
	legspeed = 90
	broken = IsBodyBroken(hed)
	broken1 = IsBodyBroken(man)
	minDist = 60
	att1 = 3
	boc = 1.6
	Thimer = 0
	trommer = 0
	troimmer = 0
	bimer = 0
	losetime = 5
	damage = 0.4
	mellerange = 3
	armspeed = 100
	hit = {
		LoadSound("MOD/enemies/zombie/fleshhit.ogg"),
		LoadSound("MOD/enemies/zombie/fleshhit1.ogg"),
		LoadSound("MOD/enemies/zombie/fleshhit2.ogg"),
		LoadSound("MOD/enemies/zombie/fleshhit3.ogg"),
		LoadSound("MOD/enemies/zombie/fleshhit4.ogg")
	}
	miss = {
		LoadSound("MOD/enemies/zombie/miss.ogg"),
		LoadSound("MOD/enemies/zombie/miss1.ogg"),
		LoadSound("MOD/enemies/zombie/miss2.ogg"),
		LoadSound("MOD/enemies/zombie/miss3.ogg"),
		LoadSound("MOD/enemies/zombie/miss4.ogg")
	}
	scream = {
		LoadSound("MOD/enemies/zombie/terrible1.ogg"),
		LoadSound("MOD/enemies/zombie/terrible2.ogg")
	}
end

-- making extra sure that the code detects broken bodies.
function tick(dt)
	gunTrans = GetShapeWorldTransform(eyes)
	gunPos = gunTrans.pos
	direction = TransformToParentVec(gunTrans, Vec(0, -1, 0))
	 shootPos = VecAdd(gunPos, VecScale(direction,0.2))
	bomer = math.random(1,4)
	PL1 = GetShapeWorldTransform(eyes)
	--randomize smoke
	rand = math.random(-0.5,0.5)
	randomsmoke1 = rand + PL1.pos[1]
	rand = math.random(0.5,-0.5)
	randomsmoke2 = rand + PL1.pos[2]
	rand = math.random(-0.5,0.5)
	randomsmoke3 = rand + PL1.pos[3]
	if canSeePlayer() then
		if not isBroken then
			seeplayer = true
			smoke()
			bimer = 0
			if not terrible then
				PlaySound(scream[math.random(#scream)])
				terrible = true
			end
		end
	else
		bimer = bimer + dt
		if bimer > losetime then
			seeplayer = false
			terrible = false
		end
	end
	if not isBroken then
		--this part is for basically saying "the zombie died", if it dies, the important values are reduced to 0, and the code stops repeating
		timer = timer + dt
		if IsShapeBroken(t1) then
			isBroken = true
		end
		if IsBodyBroken(hed) then
			isBroken = true
			boc = 0
		end
		if timer > att1 then
		end
		--this part is for basically saying "the zombie died" (repeating the same thing to make extra extra sure)
		if IsBodyBroken(man) then
			isBroken = true
			boc = 0
		end
		--this part is for checking if the zombie sprained their ankle or something, if they did, they become weaker and have a harder time moving their legs and standing up
		--this part is for making the head stay up while the zombie is alive
		timer = timer + 0.01
		local a = GetPlayerCameraTransform()
		local b = GetBodyTransform(man)
		local distToPlayer = VecLength(VecSub(a.pos, b.pos))
		local bias = Vec(0, 0, 0)
		local biasatt = Vec(0, 0, 0)
		if not isBroken then
			if (distToPlayer < midDist) then
				bias[2] = boc
			end
			--local MAN = GetShapeBody(man) (stuff im not using)
			SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
		end
		if seeplayer then
			--this part is for increasing the zombies range of sight to ALOT, also it makes the hands point towards the player.
			if not isBroken then
				if (distToPlayer < minDist) then
					trommer = trommer + dt
					troimmer = troimmer + dt
					for i = 1, 3 do
						if (a.pos[i] > b.pos[i]) then
							bias[i] = weight * armspeed
							minDist = minDist * 5000
						elseif (a.pos[i] < b.pos[i]) then
							bias[i] = -weight * armspeed
							minDist = minDist * 5000
						else
							bias[i] = 0
						end
					end
					if trommer > bomer then
						local H1 = GetShapeBody(h1)
						SetBodyVelocity(H1, VecAdd(GetBodyVelocity(H1), bias))
						trommer = 0
						PlaySound(miss[math.random(#miss)])
						if distToPlayer < mellerange then
							PlaySound(hit[math.random(#hit)])
							SetPlayerHealth(GetPlayerHealth()-damage)
						end
					end
					if troimmer > bomer * 2 then
						local H2 = GetShapeBody(h2)
						SetBodyVelocity(H2, VecAdd(GetBodyVelocity(H2), bias))
						troimmer = 0
						PlaySound(miss[math.random(#miss)])
						if distToPlayer < mellerange then
							PlaySound(hit[math.random(#hit)])
							SetPlayerHealth(GetPlayerHealth()-damage)
						end
					end
				end
			end

			--the next part takes care of the legs and the leg timer.
			if not isBroken then
				if (distToPlayer < minDist) then
					if timer > 1 then
						Thimer = Thimer + dt
					end
					if timer > 2 then
						timer = 0
						for i = 1, 3 do
							if (a.pos[i] > b.pos[i]) then
								bias[i] = weight * legspeed
								minDist = minDist * 5000
							else
								if (a.pos[i] < b.pos[i]) then
									bias[i] = -weight * legspeed
									minDist = minDist * 5000
								else
									bias[i] = 0
								end
							end
						end
						local L1 = GetShapeBody(l1)
						SetBodyVelocity(L1, VecAdd(GetBodyVelocity(L1), bias))
						SetBodyVelocity(man, VecAdd(GetBodyVelocity(man), bias))
						local H1 = GetShapeBody(h1)
						SetBodyVelocity(H1, VecAdd(GetBodyVelocity(H1), bias))
						local H2 = GetShapeBody(h2)
						SetBodyVelocity(H2, VecAdd(GetBodyVelocity(H2), bias))
						if Thimer > 0.5 then
							Thimer = 0
							for i = 1, 3 do
								bias[2] = 0
								if (a.pos[i] > b.pos[i]) then
									bias[i] = weight
									minDist = minDist * 5000
								else
									if (a.pos[i] < b.pos[i]) then
										bias[i] = -weight
										minDist = minDist * 5000
									else
										bias[i] = 0
									end
								end
								local L2 = GetShapeBody(l2)
								SetBodyVelocity(L2, VecAdd(GetBodyVelocity(L2), bias))
							end
						end
					end
				end
			end
		end
	end
end

function canSeePlayer()
	local playerPos = GetPlayerCameraTransform().pos

	--Direction to player
	local dir = VecSub(playerPos, shootPos)
	local dist = VecLength(dir)
	dir = VecNormalize(dir)

	QueryRejectVehicle(GetPlayerVehicle())
	QueryRejectBody(man)
	return not QueryRaycast(shootPos, dir, dist, 0, true)
end

function smoke()
	--spawn sparks
	ParticleReset()
	ParticleType("plain")
	ParticleColor(1,1,1)
	ParticleEmissive(100,10)
	ParticleRadius(0.02, 0.01)
	ParticleAlpha(1.0,0.0)
	ParticleCollide(1)
	ParticleGravity(0)
	ParticleDrag(0)
	ParticleStretch()
	SpawnParticle(Vec(randomsmoke1,randomsmoke2,randomsmoke3), Vec(math.random(-10,10), math.random(-10,10), math.random(-10,10)), 1)
end
