
function init()
	lamps = FindShapes("heat-lamp")
	humSound = LoadLoop("light/buzz3.ogg")
	lampCenters = {}
	for i=1, #lamps do
		local min, max = GetShapeBounds(lamps[i])
		lampCenters[i] = VecLerp(min, max, 0.5)
	end
end

function tick()
	local intensity = (math.sin(GetTime()) * 0.45) + 0.55
	for i=1, #lamps do
		SetShapeEmissiveScale(lamps[i], intensity)
		PlayLoop(humSound, lampCenters[i], intensity * 2)
	end
end